/*************************************************
* PK Key Types Source File                       *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#include <botan/pk_keys.h>
#include <botan/oids.h>

namespace Botan {

/*************************************************
* Default OID access                             *
*************************************************/
OID PK_Key::get_oid() const
   {
   const std::string algo = algo_name();

   try {
      return OIDS::lookup(algo);
   }
   catch(Lookup_Error)
      {
      throw Lookup_Error("PK algorithm " + algo + " has no defined OIDs");
      }
   }

/*************************************************
* Default OID check                              *
*************************************************/
bool PK_Key::valid_oid(const OID& oid) const
   {
   if(oid == get_oid())
      return true;
   return false;
   }

}
